'==========================================================================
' 3D-Torus
' TORUS.BAS
' Autor: Lothar Schirm
' Letzte Ueberarbeitung 11.04.08
'==========================================================================

#INCLUDE "3D-Graph.bas"

DIM AS SINGLE x0(12), y0(12), z0(12), x(12, 24), y(12, 24), z(12, 24), _
       yp(12, 24), zp(12, 24), pi, dphi, r, phi, alpha, xrot, yrot, zrot
DIM AS INTEGER i, j, Farbe

pi = 3.141593

SCREEN 12
WINDOW(-10, -10) - (10, 10)

'Ausgangsfigur ist ein Zwoelfeck in der rechten Bildhaelfte:
dphi = 30
r = 1.5
FOR i = 0 TO 12
    phi = i * dphi * pi / 180
    x0(i) = 0
    y0(i) = r * COS(phi) + 8
    z0(i) = r * SIN(phi)
NEXT i

'Torus berechnen durch Rotation der Ausgangsfigur um die z-Achse,
'anschliessende Drehung um die x-Achse und Projektion:
alpha = 15
FOR i = 0 TO 12
    FOR j = 0 TO 24
        Rotation(x0(i), y0(i), z0(i), "z", j * alpha, xrot, yrot, zrot)
        Rotation(xrot, yrot, zrot, "x", 15, x(i, j), y(i, j), z(i, j))
        Projektion(x(i, j), y(i, j), z(i, j), 30, yp(i, j), zp(i, j))
    NEXT j
NEXT i

'Torus zeichnen:
Farbe = 3
'Linien fuer j = const:
FOR i = 0 TO 12
    PSET (yp(i, 0), zp(i, 0)), Farbe
    FOR j = 0 TO 24
        LINE -(yp(i, j), zp(i, j)), Farbe
    NEXT j
NEXT i
'Linien fuer i = const:
FOR j = 0 TO 24
    PSET (yp(0, j), zp(0, j)), Farbe
    FOR i = 0 TO 12
        LINE -(yp(i, j), zp(i, j)), Farbe
    NEXT i
NEXT j
LOCATE 4, 10: PRINT "=== 3D TORUS ==="
LOCATE 30,1
PRINT "Ende: Beliebige Taste"
SLEEP

