'=========================================================================
' Waermeleitungsgleichung
' WAERME.BAS
' Autor: Lothar Schirm
' Letzte Ueberarbeitung 17.03.08
'=========================================================================


#INCLUDE "3D-Graph.bas"

DIM AS SINGLE x(10), t(20), Temp(10, 20), a, pi, xmax, b, dx, dt
DIM AS INTEGER i, j
DIM AS STRING*1 jn

Anfang:
SCREEN 0
COLOR 7, 1
CLS
PRINT "Waermeleitung durch eine Wand:"
PRINT
PRINT "Auf der Aussenflaeche einer Wand folgt die Temperatur im Tagesverlauf"
PRINT "naeherungsweise der Funktion"
PRINT "T = T0 + T1 * sin(omega * t)"
PRINT "Die Loesung der Waermeleitungsgleichung liefert dann im Inneren der Wand"
PRINT "den Temperaturverlauf"
PRINT "T = T0 + T1 * exp(-a * x) * sin(omega * t - a * x),"
PRINT "wobei a eine Konstante ist,"
PRINT "d.h. die Temperatur im Wandinnern folgt der Aussentemperatur verzoegert"
PRINT "und mit gedaempfter Amplitude."
PRINT
INPUT "a im Verhaeltnis zur Wanddicke: ", a

pi = 3.141593
xmax = 5
b = a / xmax
dx = xmax / 10
dt = 2 * pi / 20

FOR i = 0 TO 10
  x(i) = i * dx
  FOR j = 0 TO 20
    t(j) = j * dt
    Temp(i, j) = 1 + EXP(-b * x(i)) * SIN(t(j) - b * x(i))
  NEXT j
NEXT i

SCREEN 12
COLOR 0, 15
CLS
WINDOW(-4, -4) - (8, 4)
Koordinaten3D (0, 6, 0, 8, 0, 3, -20, 20, "x", "t", "T", _
               "Temperaturverteilung T(x, t) fuer a = " +STR(a))
xyzGraphik(x(), t(), Temp(), 10, 20, -20, 20, 12, 1)
INPUT "Nochmal j/n: ", jn
IF UCASE(jn) = "J" THEN GOTO Anfang


