'=========================================================================
' Rotierender Wuerfel
' WUERFEL.BAS
' Autor: Lothar Schirm
' Letzte Ueberarbeitung 11.04.08
'=========================================================================

#INCLUDE "3D-Graph.bas"

DECLARE SUB Zeichnen(Farbe AS INTEGER)

DIM AS SINGLE x(8), y(8), z(8),xneu, yneu, zneu, alpha, xrot, yrot, zrot
DIM SHARED AS SINGLE  yp(8), zp(8)             
DIM AS STRING*1 Achse, Loeschen, jn
DIM AS INTEGER VFarbe, HFarbe, i

Anfang:
SCREEN 0
CLS 0
PRINT "************************* Programm WUERFEL *************************"
PRINT
PRINT "Das Programm zeichnet einen Wuerfel auf den Bildschirm in"
PRINT "x-y-z-Koordinaten, Wuerfelmitte im Koordinatenursprung:"
PRINT
PRINT "               ^ z"
PRINT "               I"
PRINT "          +----------+"
PRINT "        / I        / I"
PRINT "      +----------+   I"
PRINT "      I   I      I   I   ---> y"
PRINT "      I   +------I---+ "
PRINT "      I /        I /"
PRINT "      +----------+"
PRINT "         /"
PRINT "       x"
PRINT
PRINT "Der Wuerfel kann um folgende Achsen gedreht werden:"
PRINT "- um die x-Achse"
PRINT "- um die y-Achse"
PRINT "- um die z-Achse"
INPUT "Achse, um die gedreht werden soll (x, y oder z): ", Achse
INPUT "Jedes Mal loeschen j/n: ", Loeschen

'Koordinaten der Wuerfelecken:
'Vordere Flaeche:
x(1) = 1: y(1) = -1: z(1) = 1   'links oben
x(2) = 1: y(2) = 1: z(2) = 1    'rechts oben
x(3) = 1: y(3) = 1: z(3) = -1   'rechts unten
x(4) = 1: y(4) = -1: z(4) = -1  'links unten
'Hintere Flaeche:
x(5) = -1: y(5) = -1: z(5) = 1  'links oben
x(6) = -1: y(6) = 1: z(6) = 1   'rechts oben
x(7) = -1: y(7) = 1: z(7) = -1  'rechts unten
x(8) = -1: y(8) = -1: z(8) = -1 'links unten

'Wuerfel zeichnen und rotieren lassen:
SCREEN 12
HFarbe = 0
VFarbe = 2
WINDOW (-2, -2) - (2, 2)
FOR alpha = 0 TO 360 STEP 5
    FOR i = 1 TO 8
        Rotation (x(i), y(i), z(i), "z", 20, xneu, yneu, zneu)
        Rotation (xneu, yneu, zneu, Achse, alpha, xrot, yrot, zrot)
        Projektion (xrot, yrot, zrot, 20, yp(i), zp(i))
    NEXT i
    'Wuerfel zeichnen
    Zeichnen(VFarbe)
    SLEEP (50)
    IF (Loeschen = "j") AND (alpha < 360) THEN Zeichnen(HFarbe) 
    'Wuerfel wieder loeschen
NEXT alpha

LOCATE 30,1
INPUT "Nochmal j/n: ", jn
IF jn = "j" THEN GOTO Anfang

END 'Hauptprogramm

'------------------------------------------------------------------------

SUB Zeichnen(Farbe AS INTEGER)
  
    DIM i AS INTEGER
    
    PSET (yp(4), zp(4))
    FOR i = 1 TO 4
        LINE -(yp(i), zp(i)), Farbe
    NEXT i
    PSET (yp(8), zp(8))
    FOR i = 5 TO 8
        LINE -(yp(i), zp(i)), Farbe
    NEXT i
    FOR i = 5 TO 8
        LINE (yp(i - 4), zp(i - 4))-(yp(i), zp(i)), Farbe
    NEXT i
    
END SUB



